//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private AdvancedADX[] cacheAdvancedADX = null;
        private AdvancedATR[] cacheAdvancedATR = null;
        private AdvancedBands[] cacheAdvancedBands = null;
        private AdvancedCCI[] cacheAdvancedCCI = null;
        private AdvancedDI[] cacheAdvancedDI = null;
        private AdvancedMACD[] cacheAdvancedMACD = null;
        private AdvancedRSI[] cacheAdvancedRSI = null;
        private AdvancedStochastics[] cacheAdvancedStochastics = null;
        private AdvancedVelocityIndexD1[] cacheAdvancedVelocityIndexD1 = null;
        private AdvancedVelocityIndexD2[] cacheAdvancedVelocityIndexD2 = null;
        private AdvancedVelocityIndexD3[] cacheAdvancedVelocityIndexD3 = null;
        private AdvancedVelocityIndexD4[] cacheAdvancedVelocityIndexD4 = null;

        private static AdvancedADX checkAdvancedADX = new AdvancedADX();
        private static AdvancedATR checkAdvancedATR = new AdvancedATR();
        private static AdvancedBands checkAdvancedBands = new AdvancedBands();
        private static AdvancedCCI checkAdvancedCCI = new AdvancedCCI();
        private static AdvancedDI checkAdvancedDI = new AdvancedDI();
        private static AdvancedMACD checkAdvancedMACD = new AdvancedMACD();
        private static AdvancedRSI checkAdvancedRSI = new AdvancedRSI();
        private static AdvancedStochastics checkAdvancedStochastics = new AdvancedStochastics();
        private static AdvancedVelocityIndexD1 checkAdvancedVelocityIndexD1 = new AdvancedVelocityIndexD1();
        private static AdvancedVelocityIndexD2 checkAdvancedVelocityIndexD2 = new AdvancedVelocityIndexD2();
        private static AdvancedVelocityIndexD3 checkAdvancedVelocityIndexD3 = new AdvancedVelocityIndexD3();
        private static AdvancedVelocityIndexD4 checkAdvancedVelocityIndexD4 = new AdvancedVelocityIndexD4();

        /// <summary>
        /// AdvancedADX
        /// </summary>
        /// <returns></returns>
        public AdvancedADX AdvancedADX(int period)
        {
            return AdvancedADX(Input, period);
        }

        /// <summary>
        /// AdvancedADX
        /// </summary>
        /// <returns></returns>
        public AdvancedADX AdvancedADX(Data.IDataSeries input, int period)
        {
            if (cacheAdvancedADX != null)
                for (int idx = 0; idx < cacheAdvancedADX.Length; idx++)
                    if (cacheAdvancedADX[idx].Period == period && cacheAdvancedADX[idx].EqualsInput(input))
                        return cacheAdvancedADX[idx];

            lock (checkAdvancedADX)
            {
                checkAdvancedADX.Period = period;
                period = checkAdvancedADX.Period;

                if (cacheAdvancedADX != null)
                    for (int idx = 0; idx < cacheAdvancedADX.Length; idx++)
                        if (cacheAdvancedADX[idx].Period == period && cacheAdvancedADX[idx].EqualsInput(input))
                            return cacheAdvancedADX[idx];

                AdvancedADX indicator = new AdvancedADX();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedADX[] tmp = new AdvancedADX[cacheAdvancedADX == null ? 1 : cacheAdvancedADX.Length + 1];
                if (cacheAdvancedADX != null)
                    cacheAdvancedADX.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedADX = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedATR
        /// </summary>
        /// <returns></returns>
        public AdvancedATR AdvancedATR(int period)
        {
            return AdvancedATR(Input, period);
        }

        /// <summary>
        /// AdvancedATR
        /// </summary>
        /// <returns></returns>
        public AdvancedATR AdvancedATR(Data.IDataSeries input, int period)
        {
            if (cacheAdvancedATR != null)
                for (int idx = 0; idx < cacheAdvancedATR.Length; idx++)
                    if (cacheAdvancedATR[idx].Period == period && cacheAdvancedATR[idx].EqualsInput(input))
                        return cacheAdvancedATR[idx];

            lock (checkAdvancedATR)
            {
                checkAdvancedATR.Period = period;
                period = checkAdvancedATR.Period;

                if (cacheAdvancedATR != null)
                    for (int idx = 0; idx < cacheAdvancedATR.Length; idx++)
                        if (cacheAdvancedATR[idx].Period == period && cacheAdvancedATR[idx].EqualsInput(input))
                            return cacheAdvancedATR[idx];

                AdvancedATR indicator = new AdvancedATR();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedATR[] tmp = new AdvancedATR[cacheAdvancedATR == null ? 1 : cacheAdvancedATR.Length + 1];
                if (cacheAdvancedATR != null)
                    cacheAdvancedATR.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedATR = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedBands
        /// </summary>
        /// <returns></returns>
        public AdvancedBands AdvancedBands(double numStdDev, int period)
        {
            return AdvancedBands(Input, numStdDev, period);
        }

        /// <summary>
        /// AdvancedBands
        /// </summary>
        /// <returns></returns>
        public AdvancedBands AdvancedBands(Data.IDataSeries input, double numStdDev, int period)
        {
            if (cacheAdvancedBands != null)
                for (int idx = 0; idx < cacheAdvancedBands.Length; idx++)
                    if (Math.Abs(cacheAdvancedBands[idx].NumStdDev - numStdDev) <= double.Epsilon && cacheAdvancedBands[idx].Period == period && cacheAdvancedBands[idx].EqualsInput(input))
                        return cacheAdvancedBands[idx];

            lock (checkAdvancedBands)
            {
                checkAdvancedBands.NumStdDev = numStdDev;
                numStdDev = checkAdvancedBands.NumStdDev;
                checkAdvancedBands.Period = period;
                period = checkAdvancedBands.Period;

                if (cacheAdvancedBands != null)
                    for (int idx = 0; idx < cacheAdvancedBands.Length; idx++)
                        if (Math.Abs(cacheAdvancedBands[idx].NumStdDev - numStdDev) <= double.Epsilon && cacheAdvancedBands[idx].Period == period && cacheAdvancedBands[idx].EqualsInput(input))
                            return cacheAdvancedBands[idx];

                AdvancedBands indicator = new AdvancedBands();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.NumStdDev = numStdDev;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedBands[] tmp = new AdvancedBands[cacheAdvancedBands == null ? 1 : cacheAdvancedBands.Length + 1];
                if (cacheAdvancedBands != null)
                    cacheAdvancedBands.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedBands = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedCCI
        /// </summary>
        /// <returns></returns>
        public AdvancedCCI AdvancedCCI(int period)
        {
            return AdvancedCCI(Input, period);
        }

        /// <summary>
        /// AdvancedCCI
        /// </summary>
        /// <returns></returns>
        public AdvancedCCI AdvancedCCI(Data.IDataSeries input, int period)
        {
            if (cacheAdvancedCCI != null)
                for (int idx = 0; idx < cacheAdvancedCCI.Length; idx++)
                    if (cacheAdvancedCCI[idx].Period == period && cacheAdvancedCCI[idx].EqualsInput(input))
                        return cacheAdvancedCCI[idx];

            lock (checkAdvancedCCI)
            {
                checkAdvancedCCI.Period = period;
                period = checkAdvancedCCI.Period;

                if (cacheAdvancedCCI != null)
                    for (int idx = 0; idx < cacheAdvancedCCI.Length; idx++)
                        if (cacheAdvancedCCI[idx].Period == period && cacheAdvancedCCI[idx].EqualsInput(input))
                            return cacheAdvancedCCI[idx];

                AdvancedCCI indicator = new AdvancedCCI();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedCCI[] tmp = new AdvancedCCI[cacheAdvancedCCI == null ? 1 : cacheAdvancedCCI.Length + 1];
                if (cacheAdvancedCCI != null)
                    cacheAdvancedCCI.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedCCI = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedDI
        /// </summary>
        /// <returns></returns>
        public AdvancedDI AdvancedDI(int period)
        {
            return AdvancedDI(Input, period);
        }

        /// <summary>
        /// AdvancedDI
        /// </summary>
        /// <returns></returns>
        public AdvancedDI AdvancedDI(Data.IDataSeries input, int period)
        {
            if (cacheAdvancedDI != null)
                for (int idx = 0; idx < cacheAdvancedDI.Length; idx++)
                    if (cacheAdvancedDI[idx].Period == period && cacheAdvancedDI[idx].EqualsInput(input))
                        return cacheAdvancedDI[idx];

            lock (checkAdvancedDI)
            {
                checkAdvancedDI.Period = period;
                period = checkAdvancedDI.Period;

                if (cacheAdvancedDI != null)
                    for (int idx = 0; idx < cacheAdvancedDI.Length; idx++)
                        if (cacheAdvancedDI[idx].Period == period && cacheAdvancedDI[idx].EqualsInput(input))
                            return cacheAdvancedDI[idx];

                AdvancedDI indicator = new AdvancedDI();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedDI[] tmp = new AdvancedDI[cacheAdvancedDI == null ? 1 : cacheAdvancedDI.Length + 1];
                if (cacheAdvancedDI != null)
                    cacheAdvancedDI.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedDI = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedMACD
        /// </summary>
        /// <returns></returns>
        public AdvancedMACD AdvancedMACD(int fast, int slow, int smooth)
        {
            return AdvancedMACD(Input, fast, slow, smooth);
        }

        /// <summary>
        /// AdvancedMACD
        /// </summary>
        /// <returns></returns>
        public AdvancedMACD AdvancedMACD(Data.IDataSeries input, int fast, int slow, int smooth)
        {
            if (cacheAdvancedMACD != null)
                for (int idx = 0; idx < cacheAdvancedMACD.Length; idx++)
                    if (cacheAdvancedMACD[idx].Fast == fast && cacheAdvancedMACD[idx].Slow == slow && cacheAdvancedMACD[idx].Smooth == smooth && cacheAdvancedMACD[idx].EqualsInput(input))
                        return cacheAdvancedMACD[idx];

            lock (checkAdvancedMACD)
            {
                checkAdvancedMACD.Fast = fast;
                fast = checkAdvancedMACD.Fast;
                checkAdvancedMACD.Slow = slow;
                slow = checkAdvancedMACD.Slow;
                checkAdvancedMACD.Smooth = smooth;
                smooth = checkAdvancedMACD.Smooth;

                if (cacheAdvancedMACD != null)
                    for (int idx = 0; idx < cacheAdvancedMACD.Length; idx++)
                        if (cacheAdvancedMACD[idx].Fast == fast && cacheAdvancedMACD[idx].Slow == slow && cacheAdvancedMACD[idx].Smooth == smooth && cacheAdvancedMACD[idx].EqualsInput(input))
                            return cacheAdvancedMACD[idx];

                AdvancedMACD indicator = new AdvancedMACD();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Fast = fast;
                indicator.Slow = slow;
                indicator.Smooth = smooth;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedMACD[] tmp = new AdvancedMACD[cacheAdvancedMACD == null ? 1 : cacheAdvancedMACD.Length + 1];
                if (cacheAdvancedMACD != null)
                    cacheAdvancedMACD.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedMACD = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedRSI
        /// </summary>
        /// <returns></returns>
        public AdvancedRSI AdvancedRSI(int period, int smooth)
        {
            return AdvancedRSI(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedRSI
        /// </summary>
        /// <returns></returns>
        public AdvancedRSI AdvancedRSI(Data.IDataSeries input, int period, int smooth)
        {
            if (cacheAdvancedRSI != null)
                for (int idx = 0; idx < cacheAdvancedRSI.Length; idx++)
                    if (cacheAdvancedRSI[idx].Period == period && cacheAdvancedRSI[idx].Smooth == smooth && cacheAdvancedRSI[idx].EqualsInput(input))
                        return cacheAdvancedRSI[idx];

            lock (checkAdvancedRSI)
            {
                checkAdvancedRSI.Period = period;
                period = checkAdvancedRSI.Period;
                checkAdvancedRSI.Smooth = smooth;
                smooth = checkAdvancedRSI.Smooth;

                if (cacheAdvancedRSI != null)
                    for (int idx = 0; idx < cacheAdvancedRSI.Length; idx++)
                        if (cacheAdvancedRSI[idx].Period == period && cacheAdvancedRSI[idx].Smooth == smooth && cacheAdvancedRSI[idx].EqualsInput(input))
                            return cacheAdvancedRSI[idx];

                AdvancedRSI indicator = new AdvancedRSI();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                indicator.Smooth = smooth;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedRSI[] tmp = new AdvancedRSI[cacheAdvancedRSI == null ? 1 : cacheAdvancedRSI.Length + 1];
                if (cacheAdvancedRSI != null)
                    cacheAdvancedRSI.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedRSI = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedStochastics
        /// </summary>
        /// <returns></returns>
        public AdvancedStochastics AdvancedStochastics(int periodD, int periodK, int smooth)
        {
            return AdvancedStochastics(Input, periodD, periodK, smooth);
        }

        /// <summary>
        /// AdvancedStochastics
        /// </summary>
        /// <returns></returns>
        public AdvancedStochastics AdvancedStochastics(Data.IDataSeries input, int periodD, int periodK, int smooth)
        {
            if (cacheAdvancedStochastics != null)
                for (int idx = 0; idx < cacheAdvancedStochastics.Length; idx++)
                    if (cacheAdvancedStochastics[idx].PeriodD == periodD && cacheAdvancedStochastics[idx].PeriodK == periodK && cacheAdvancedStochastics[idx].Smooth == smooth && cacheAdvancedStochastics[idx].EqualsInput(input))
                        return cacheAdvancedStochastics[idx];

            lock (checkAdvancedStochastics)
            {
                checkAdvancedStochastics.PeriodD = periodD;
                periodD = checkAdvancedStochastics.PeriodD;
                checkAdvancedStochastics.PeriodK = periodK;
                periodK = checkAdvancedStochastics.PeriodK;
                checkAdvancedStochastics.Smooth = smooth;
                smooth = checkAdvancedStochastics.Smooth;

                if (cacheAdvancedStochastics != null)
                    for (int idx = 0; idx < cacheAdvancedStochastics.Length; idx++)
                        if (cacheAdvancedStochastics[idx].PeriodD == periodD && cacheAdvancedStochastics[idx].PeriodK == periodK && cacheAdvancedStochastics[idx].Smooth == smooth && cacheAdvancedStochastics[idx].EqualsInput(input))
                            return cacheAdvancedStochastics[idx];

                AdvancedStochastics indicator = new AdvancedStochastics();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.PeriodD = periodD;
                indicator.PeriodK = periodK;
                indicator.Smooth = smooth;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedStochastics[] tmp = new AdvancedStochastics[cacheAdvancedStochastics == null ? 1 : cacheAdvancedStochastics.Length + 1];
                if (cacheAdvancedStochastics != null)
                    cacheAdvancedStochastics.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedStochastics = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedVelocityIndexD1, AVX-D1
        /// </summary>
        /// <returns></returns>
        public AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(int period, int smooth)
        {
            return AdvancedVelocityIndexD1(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD1, AVX-D1
        /// </summary>
        /// <returns></returns>
        public AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(Data.IDataSeries input, int period, int smooth)
        {
            if (cacheAdvancedVelocityIndexD1 != null)
                for (int idx = 0; idx < cacheAdvancedVelocityIndexD1.Length; idx++)
                    if (cacheAdvancedVelocityIndexD1[idx].Period == period && cacheAdvancedVelocityIndexD1[idx].Smooth == smooth && cacheAdvancedVelocityIndexD1[idx].EqualsInput(input))
                        return cacheAdvancedVelocityIndexD1[idx];

            lock (checkAdvancedVelocityIndexD1)
            {
                checkAdvancedVelocityIndexD1.Period = period;
                period = checkAdvancedVelocityIndexD1.Period;
                checkAdvancedVelocityIndexD1.Smooth = smooth;
                smooth = checkAdvancedVelocityIndexD1.Smooth;

                if (cacheAdvancedVelocityIndexD1 != null)
                    for (int idx = 0; idx < cacheAdvancedVelocityIndexD1.Length; idx++)
                        if (cacheAdvancedVelocityIndexD1[idx].Period == period && cacheAdvancedVelocityIndexD1[idx].Smooth == smooth && cacheAdvancedVelocityIndexD1[idx].EqualsInput(input))
                            return cacheAdvancedVelocityIndexD1[idx];

                AdvancedVelocityIndexD1 indicator = new AdvancedVelocityIndexD1();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                indicator.Smooth = smooth;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedVelocityIndexD1[] tmp = new AdvancedVelocityIndexD1[cacheAdvancedVelocityIndexD1 == null ? 1 : cacheAdvancedVelocityIndexD1.Length + 1];
                if (cacheAdvancedVelocityIndexD1 != null)
                    cacheAdvancedVelocityIndexD1.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedVelocityIndexD1 = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedVelocityIndexD2, AVX-D2
        /// </summary>
        /// <returns></returns>
        public AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(int period, int smooth)
        {
            return AdvancedVelocityIndexD2(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD2, AVX-D2
        /// </summary>
        /// <returns></returns>
        public AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(Data.IDataSeries input, int period, int smooth)
        {
            if (cacheAdvancedVelocityIndexD2 != null)
                for (int idx = 0; idx < cacheAdvancedVelocityIndexD2.Length; idx++)
                    if (cacheAdvancedVelocityIndexD2[idx].Period == period && cacheAdvancedVelocityIndexD2[idx].Smooth == smooth && cacheAdvancedVelocityIndexD2[idx].EqualsInput(input))
                        return cacheAdvancedVelocityIndexD2[idx];

            lock (checkAdvancedVelocityIndexD2)
            {
                checkAdvancedVelocityIndexD2.Period = period;
                period = checkAdvancedVelocityIndexD2.Period;
                checkAdvancedVelocityIndexD2.Smooth = smooth;
                smooth = checkAdvancedVelocityIndexD2.Smooth;

                if (cacheAdvancedVelocityIndexD2 != null)
                    for (int idx = 0; idx < cacheAdvancedVelocityIndexD2.Length; idx++)
                        if (cacheAdvancedVelocityIndexD2[idx].Period == period && cacheAdvancedVelocityIndexD2[idx].Smooth == smooth && cacheAdvancedVelocityIndexD2[idx].EqualsInput(input))
                            return cacheAdvancedVelocityIndexD2[idx];

                AdvancedVelocityIndexD2 indicator = new AdvancedVelocityIndexD2();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                indicator.Smooth = smooth;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedVelocityIndexD2[] tmp = new AdvancedVelocityIndexD2[cacheAdvancedVelocityIndexD2 == null ? 1 : cacheAdvancedVelocityIndexD2.Length + 1];
                if (cacheAdvancedVelocityIndexD2 != null)
                    cacheAdvancedVelocityIndexD2.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedVelocityIndexD2 = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedVelocityIndexD3, AVX-D3
        /// </summary>
        /// <returns></returns>
        public AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(int period, int smooth)
        {
            return AdvancedVelocityIndexD3(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD3, AVX-D3
        /// </summary>
        /// <returns></returns>
        public AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(Data.IDataSeries input, int period, int smooth)
        {
            if (cacheAdvancedVelocityIndexD3 != null)
                for (int idx = 0; idx < cacheAdvancedVelocityIndexD3.Length; idx++)
                    if (cacheAdvancedVelocityIndexD3[idx].Period == period && cacheAdvancedVelocityIndexD3[idx].Smooth == smooth && cacheAdvancedVelocityIndexD3[idx].EqualsInput(input))
                        return cacheAdvancedVelocityIndexD3[idx];

            lock (checkAdvancedVelocityIndexD3)
            {
                checkAdvancedVelocityIndexD3.Period = period;
                period = checkAdvancedVelocityIndexD3.Period;
                checkAdvancedVelocityIndexD3.Smooth = smooth;
                smooth = checkAdvancedVelocityIndexD3.Smooth;

                if (cacheAdvancedVelocityIndexD3 != null)
                    for (int idx = 0; idx < cacheAdvancedVelocityIndexD3.Length; idx++)
                        if (cacheAdvancedVelocityIndexD3[idx].Period == period && cacheAdvancedVelocityIndexD3[idx].Smooth == smooth && cacheAdvancedVelocityIndexD3[idx].EqualsInput(input))
                            return cacheAdvancedVelocityIndexD3[idx];

                AdvancedVelocityIndexD3 indicator = new AdvancedVelocityIndexD3();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                indicator.Smooth = smooth;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedVelocityIndexD3[] tmp = new AdvancedVelocityIndexD3[cacheAdvancedVelocityIndexD3 == null ? 1 : cacheAdvancedVelocityIndexD3.Length + 1];
                if (cacheAdvancedVelocityIndexD3 != null)
                    cacheAdvancedVelocityIndexD3.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedVelocityIndexD3 = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// AdvancedVelocityIndexD4, AVX-D4
        /// </summary>
        /// <returns></returns>
        public AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(int period, int smooth)
        {
            return AdvancedVelocityIndexD4(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD4, AVX-D4
        /// </summary>
        /// <returns></returns>
        public AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(Data.IDataSeries input, int period, int smooth)
        {
            if (cacheAdvancedVelocityIndexD4 != null)
                for (int idx = 0; idx < cacheAdvancedVelocityIndexD4.Length; idx++)
                    if (cacheAdvancedVelocityIndexD4[idx].Period == period && cacheAdvancedVelocityIndexD4[idx].Smooth == smooth && cacheAdvancedVelocityIndexD4[idx].EqualsInput(input))
                        return cacheAdvancedVelocityIndexD4[idx];

            lock (checkAdvancedVelocityIndexD4)
            {
                checkAdvancedVelocityIndexD4.Period = period;
                period = checkAdvancedVelocityIndexD4.Period;
                checkAdvancedVelocityIndexD4.Smooth = smooth;
                smooth = checkAdvancedVelocityIndexD4.Smooth;

                if (cacheAdvancedVelocityIndexD4 != null)
                    for (int idx = 0; idx < cacheAdvancedVelocityIndexD4.Length; idx++)
                        if (cacheAdvancedVelocityIndexD4[idx].Period == period && cacheAdvancedVelocityIndexD4[idx].Smooth == smooth && cacheAdvancedVelocityIndexD4[idx].EqualsInput(input))
                            return cacheAdvancedVelocityIndexD4[idx];

                AdvancedVelocityIndexD4 indicator = new AdvancedVelocityIndexD4();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                indicator.Smooth = smooth;
                Indicators.Add(indicator);
                indicator.SetUp();

                AdvancedVelocityIndexD4[] tmp = new AdvancedVelocityIndexD4[cacheAdvancedVelocityIndexD4 == null ? 1 : cacheAdvancedVelocityIndexD4.Length + 1];
                if (cacheAdvancedVelocityIndexD4 != null)
                    cacheAdvancedVelocityIndexD4.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAdvancedVelocityIndexD4 = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// AdvancedADX
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedADX AdvancedADX(int period)
        {
            return _indicator.AdvancedADX(Input, period);
        }

        /// <summary>
        /// AdvancedADX
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedADX AdvancedADX(Data.IDataSeries input, int period)
        {
            return _indicator.AdvancedADX(input, period);
        }

        /// <summary>
        /// AdvancedATR
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedATR AdvancedATR(int period)
        {
            return _indicator.AdvancedATR(Input, period);
        }

        /// <summary>
        /// AdvancedATR
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedATR AdvancedATR(Data.IDataSeries input, int period)
        {
            return _indicator.AdvancedATR(input, period);
        }

        /// <summary>
        /// AdvancedBands
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedBands AdvancedBands(double numStdDev, int period)
        {
            return _indicator.AdvancedBands(Input, numStdDev, period);
        }

        /// <summary>
        /// AdvancedBands
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedBands AdvancedBands(Data.IDataSeries input, double numStdDev, int period)
        {
            return _indicator.AdvancedBands(input, numStdDev, period);
        }

        /// <summary>
        /// AdvancedCCI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedCCI AdvancedCCI(int period)
        {
            return _indicator.AdvancedCCI(Input, period);
        }

        /// <summary>
        /// AdvancedCCI
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedCCI AdvancedCCI(Data.IDataSeries input, int period)
        {
            return _indicator.AdvancedCCI(input, period);
        }

        /// <summary>
        /// AdvancedDI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedDI AdvancedDI(int period)
        {
            return _indicator.AdvancedDI(Input, period);
        }

        /// <summary>
        /// AdvancedDI
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedDI AdvancedDI(Data.IDataSeries input, int period)
        {
            return _indicator.AdvancedDI(input, period);
        }

        /// <summary>
        /// AdvancedMACD
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedMACD AdvancedMACD(int fast, int slow, int smooth)
        {
            return _indicator.AdvancedMACD(Input, fast, slow, smooth);
        }

        /// <summary>
        /// AdvancedMACD
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedMACD AdvancedMACD(Data.IDataSeries input, int fast, int slow, int smooth)
        {
            return _indicator.AdvancedMACD(input, fast, slow, smooth);
        }

        /// <summary>
        /// AdvancedRSI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedRSI AdvancedRSI(int period, int smooth)
        {
            return _indicator.AdvancedRSI(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedRSI
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedRSI AdvancedRSI(Data.IDataSeries input, int period, int smooth)
        {
            return _indicator.AdvancedRSI(input, period, smooth);
        }

        /// <summary>
        /// AdvancedStochastics
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedStochastics AdvancedStochastics(int periodD, int periodK, int smooth)
        {
            return _indicator.AdvancedStochastics(Input, periodD, periodK, smooth);
        }

        /// <summary>
        /// AdvancedStochastics
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedStochastics AdvancedStochastics(Data.IDataSeries input, int periodD, int periodK, int smooth)
        {
            return _indicator.AdvancedStochastics(input, periodD, periodK, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD1, AVX-D1
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD1(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD1, AVX-D1
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(Data.IDataSeries input, int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD1(input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD2, AVX-D2
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD2(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD2, AVX-D2
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(Data.IDataSeries input, int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD2(input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD3, AVX-D3
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD3(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD3, AVX-D3
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(Data.IDataSeries input, int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD3(input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD4, AVX-D4
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD4(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD4, AVX-D4
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(Data.IDataSeries input, int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD4(input, period, smooth);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// AdvancedADX
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedADX AdvancedADX(int period)
        {
            return _indicator.AdvancedADX(Input, period);
        }

        /// <summary>
        /// AdvancedADX
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedADX AdvancedADX(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedADX(input, period);
        }

        /// <summary>
        /// AdvancedATR
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedATR AdvancedATR(int period)
        {
            return _indicator.AdvancedATR(Input, period);
        }

        /// <summary>
        /// AdvancedATR
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedATR AdvancedATR(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedATR(input, period);
        }

        /// <summary>
        /// AdvancedBands
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedBands AdvancedBands(double numStdDev, int period)
        {
            return _indicator.AdvancedBands(Input, numStdDev, period);
        }

        /// <summary>
        /// AdvancedBands
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedBands AdvancedBands(Data.IDataSeries input, double numStdDev, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedBands(input, numStdDev, period);
        }

        /// <summary>
        /// AdvancedCCI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedCCI AdvancedCCI(int period)
        {
            return _indicator.AdvancedCCI(Input, period);
        }

        /// <summary>
        /// AdvancedCCI
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedCCI AdvancedCCI(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedCCI(input, period);
        }

        /// <summary>
        /// AdvancedDI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedDI AdvancedDI(int period)
        {
            return _indicator.AdvancedDI(Input, period);
        }

        /// <summary>
        /// AdvancedDI
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedDI AdvancedDI(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedDI(input, period);
        }

        /// <summary>
        /// AdvancedMACD
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedMACD AdvancedMACD(int fast, int slow, int smooth)
        {
            return _indicator.AdvancedMACD(Input, fast, slow, smooth);
        }

        /// <summary>
        /// AdvancedMACD
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedMACD AdvancedMACD(Data.IDataSeries input, int fast, int slow, int smooth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedMACD(input, fast, slow, smooth);
        }

        /// <summary>
        /// AdvancedRSI
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedRSI AdvancedRSI(int period, int smooth)
        {
            return _indicator.AdvancedRSI(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedRSI
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedRSI AdvancedRSI(Data.IDataSeries input, int period, int smooth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedRSI(input, period, smooth);
        }

        /// <summary>
        /// AdvancedStochastics
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedStochastics AdvancedStochastics(int periodD, int periodK, int smooth)
        {
            return _indicator.AdvancedStochastics(Input, periodD, periodK, smooth);
        }

        /// <summary>
        /// AdvancedStochastics
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedStochastics AdvancedStochastics(Data.IDataSeries input, int periodD, int periodK, int smooth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedStochastics(input, periodD, periodK, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD1, AVX-D1
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD1(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD1, AVX-D1
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(Data.IDataSeries input, int period, int smooth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedVelocityIndexD1(input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD2, AVX-D2
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD2(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD2, AVX-D2
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(Data.IDataSeries input, int period, int smooth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedVelocityIndexD2(input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD3, AVX-D3
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD3(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD3, AVX-D3
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(Data.IDataSeries input, int period, int smooth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedVelocityIndexD3(input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD4, AVX-D4
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(int period, int smooth)
        {
            return _indicator.AdvancedVelocityIndexD4(Input, period, smooth);
        }

        /// <summary>
        /// AdvancedVelocityIndexD4, AVX-D4
        /// </summary>
        /// <returns></returns>
        public Indicator.AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(Data.IDataSeries input, int period, int smooth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AdvancedVelocityIndexD4(input, period, smooth);
        }
    }
}
#endregion
